/* 
 * File:   SList.h
 * Author: Pavel Strnad
 *
 * Created on 29. říjen 2010, 17:32
 */

#ifndef _SLIST_H
#define	_SLIST_H

#include "SHandle.h"
#include "SItem.h"

class SList {
public:
    SList();
    SHandle *head();
    SHandle *first();
    SHandle *last();
    bool isEmpty();
    void popFront();
    SHandle *pushFront(SItem);
    SHandle *pushBack(SItem);
    void insertAfter(SHandle *, SItem);
    void concat(SList *);

    void remove(SHandle *);
    SHandle *findNext(SItem *, SHandle *);
    void moveAfter(SHandle *,SHandle *);
    void moveToFront(SHandle *);
    void moveToBack(SHandle *);
    void makeEmpty();

    SList(const SList& orig);
    virtual ~SList();
private:

};

#endif	/* _SLIST_H */

